# DataSource

#### new Cesium.DataSource()
engine/Source/DataSources/DataSource.js 13

Defines the interface for data sources, which turn arbitrary data into a `EntityCollection` for generic consumption. This object is an interface for documentation purposes and is not intended to be instantiated directly.

##### See:

- Entity
- DataSourceDisplay

### Members

#### changedEvent : Event
engine/Source/DataSources/DataSource.js 55

Gets an event that will be raised when the underlying data changes.

#### clock : DataSourceClock
engine/Source/DataSources/DataSource.js 31

Gets the preferred clock settings for this data source.

#### clustering : EntityCluster
engine/Source/DataSources/DataSource.js 89

Gets or sets the clustering options for this data source. This object can be shared between multiple data sources.

#### entities : EntityCollection
engine/Source/DataSources/DataSource.js 39

Gets the collection of `Entity` instances.

#### errorEvent : Event.<function(this, RequestErrorEvent)>
engine/Source/DataSources/DataSource.js 63

Gets an event that will be raised if an error is encountered during processing.

#### isLoading : boolean
engine/Source/DataSources/DataSource.js 47

Gets a value indicating if the data source is currently loading data.

#### loadingEvent : Event.<function(this, boolean)>
engine/Source/DataSources/DataSource.js 71

Gets an event that will be raised when the value of isLoading changes.

#### name : string
engine/Source/DataSources/DataSource.js 23

Gets a human-readable name for this instance.

#### show : boolean
engine/Source/DataSources/DataSource.js 79

Gets whether or not this data source should be displayed.

### Methods

#### update(time) → boolean
engine/Source/DataSources/DataSource.js 103

Updates the data source to the provided time. This function is optional and is not required to be implemented. It is provided for data sources which retrieve data based on the current animation time or scene state. If implemented, update will be called by `DataSourceDisplay` once a frame.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The simulation time.

##### Returns:

True if this data source is ready to be displayed at the provided time, false otherwise.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.